
package Card;

/**
 *
 * @author by gigi - Ivrea TO - 
 */
import java.io.File;
import java.io.FileReader;
import java.io.BufferedReader;

public class CardRead {
    public static boolean fileOk=true; 
    static boolean newRegisterFlag=false; 
    public static int programLine=1;
    public static boolean cardParityError=false;
    public static File f;
    public static FileReader fr =null;
    public static BufferedReader br;
    static  byte aCode=0,iCode=0;

    static char[]parityArray =  {'0','1','1','0','1','0','0','1',
            '1','0','0','1','0','1','1','0'} ;    
    static int[]hexArray = {0x00,0x11,0x22,0x33,0x44,0x55,0x66,0x77,0x88,0x99,
            0xaa,0xbb,0xcc,0xdd,0xee,0xff};
    
    public  CardRead(File f) {
        
        try {
            fr = new FileReader(f);
        }
        catch  (Exception e) {
        
        }
        br = new BufferedReader(fr);   
    }
    
    public static void readCardByte()  {     
        boolean parityFlag;
        boolean parityError; 
        int stringLength;
        byte checkRead;
        byte[] byteArray;
        
        String eachLine = "null";
        parityError=false;
        
        if (fileOk) {
            try{
                eachLine = br.readLine();    
            }
            catch  (Exception e) {
                System.out.println(" Error reading Card File");           
            }        
            if (eachLine == null) {                
                try {
                    System.out.println(" End of file " );
                    br.close();
                }
                catch  (Exception e) {
                    System.out.println(" Error closing Card File");
                }
                System.out.print(" Card Parity Error "+cardParityError);     
                fileOk =false;
                Emula.P101.SOFlag=false;
//                return;
            }   
            else {  
                checkRead='0';
                parityFlag=false;
                stringLength=eachLine.length();
                System.out.print
                    (" Program line "+programLine+" Read "+eachLine);
                if ((stringLength<=1)|(stringLength>=4)) { 
                    if (stringLength>=4)
                        System.out.println(" Error Line Length <2 0r >4");
                    return;
                }
                else  {
                    byteArray=eachLine.getBytes();            
                }
                programLine+=1;    
                cardCycleRead(stringLength,byteArray);
                if (stringLength==2)    {                              
                    checkRead=byteArray[1];
                    checkRead-=48;
                    if(parityArray[iCode]=='1')    parityFlag=true; 
                    if(((checkRead==0)&(parityFlag)) |
                        ((checkRead==1)& !(parityFlag))) parityError=true; 
                }                  
                else if (stringLength==3) {
                    checkRead=(byteArray[2]);
                    checkRead-=48;
                    if(parityArray[aCode]!=parityArray[iCode])parityFlag=true; 
                    if(((checkRead==0)&(parityFlag))|
                        ((checkRead==1)& !(parityFlag)))    parityError=true;                     
                }            
                System.out.println(" Parity - Computed "+parityFlag+
                    " Read "+(checkRead)+" Error "+parityError);
                if(parityError) {
                    cardParityError=true;
                    Emula.P101.setError("CardParityError"); 
//                    Emula.P101.errorFlag=true;
                }
            }                          
        }
    }
    
    static void cardCycleRead(int strLength,byte[] bArray){
        // Move object program to P101 registers
        int charValue;
        int codeLine;
        int addCode,insCode;
        aCode=0;
        
        if (strLength==3) {
                aCode=bArray[0];
                iCode=bArray[1];
        }
        else    iCode=bArray[0];
        if (aCode>0){
            if (aCode>=60) aCode-=55;
            else aCode-=48;
        }
        if (iCode >=60) iCode-=55;
        else iCode-=48;
        addCode=hexArray[aCode]&0x0f;
        insCode=hexArray[iCode]&0xf0;
        codeLine=addCode|insCode;
        
        if(Emula.P101.firstCardCycle){
            Emula.P101.firstCardCycle =false; 
            programLine=1;
            Emula.P101.indexPgReg=0;                        
            if (Emula.P101.printProgram)
                Emula.P101.indexPgReg=3;             
            //Delete previus TA in R
            for (int i=23;i>=0;i--)   {
                charValue=Emula.P101.readRegChar(7, i);
                Emula.P101.writeRegChar(7,i,charValue&0xfe);
            }
            // Write TA in 24° char of R
            charValue=Emula.P101.readRegChar(7, 23);
            Emula.P101.writeRegChar(7,23,charValue|0x01);                
            //Clear register D,E
            Emula.P101.indexPgReg = 3;
            for(int i=0;i<24;i++){
                Emula.P101.writeRegChar(2,i,0);
                Emula.P101.writeRegChar(3,i,0);
            }
            if(!Emula.P101.printProgram) {
                //Clear register G,I,F
                Emula.P101.indexPgReg = 0;
                for(int i=0;i<24;i++){
                    Emula.P101.writeRegChar(8,i,0);
                    Emula.P101.writeRegChar(6,i,0);
                    Emula.P101.writeRegChar(4,i,0);
                }
            }                
            Emula.P101.pgReg= Emula.P101.pgRegTable[Emula.P101.indexPgReg];
            Emula.P101.writeRegChar(Emula.P101.pgReg,0,codeLine);
            //Move TA on R from char 23 to char 0
            Emula.P101.writeRegChar(7,23,charValue&0xf7);
            charValue=Emula.P101.readRegChar(7,0);
            Emula.P101.writeRegChar(7,0,charValue|0x01);
            Emula.P101.charTAofR=0;
        }
        else {
            // No first instruction
            charValue=Emula.P101.readRegChar (7,Emula.P101.charTAofR);
            Emula.P101.writeRegChar(7,Emula.P101.charTAofR,charValue&0xfe);
                
            Emula.P101.charTAofR+=1;
            if(Emula.P101.charTAofR==24){
                Emula.P101.charTAofR=0;
                if(Emula.P101.indexPgReg<=3){
                    Emula.P101.indexPgReg+=1;
                    Emula.P101.pgReg=
                            Emula.P101.pgRegTable[Emula.P101.indexPgReg];                    
                }
                else {
                    // Error for program overflow
//                    Emula.P101.errorFlag=true;
                    Emula.P101.setError (" Status SA-Program Overflow");
//                    System.out.println(" Card overflow >120 Instruction");
                    Emula.P101.SOFlag=false;
                    return;
                }
            }
            //Write new TA in R
            charValue=Emula.P101.readRegChar (7,Emula.P101.charTAofR);
            Emula.P101.writeRegChar(7,Emula.P101.charTAofR,charValue|0x01);
            //Write Instruction code
            Emula.P101.writeRegChar
                    (Emula.P101.pgReg,Emula.P101.charTAofR,codeLine);
        }
    }
  }    