/*
 * p101Emulator.java
 *
 * Created on 14-mar-2011, 14.30.28
 */
package Card;

/**
 *
 * @author by gigi - Ivrea TO -
 */

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;

public class CardToTxt {
    
  public static void call(File f)  {
      
    char alfa,beta;
    boolean parityFlag;
    int stringLength;
    int programLine;
    int programLineEnd;
    char instrSymbol;
    char addressSymbol;
    FileReader fr =null;
    char [] charArray;
    boolean fileOk =true;
    boolean checkReadFlag;
    boolean checkComputedA;
    boolean checkComputedB;
    String newLine ;

    try {
        fr = new FileReader(f);
    }
    catch  (Exception e) {
        
    }
    BufferedReader br = new BufferedReader(fr);    
    StringBuilder sb = new StringBuilder();
     
    programLine=0;    
    programLineEnd=120;
    if( Emula.P101.printProgram)    {programLineEnd=48;}
    
    while (fileOk) {
//        newLine=null;
        try{
            newLine = br.readLine();    
        }
        catch  (Exception e) {
            System.err.println(" Error reading file");
            return;
        }        
            
        if (newLine == null) {
            fileOk =false;
            System.out.println(" End of file");
            try{
                br.close();
            }
            catch  (Exception e) {
                System.err.println(" Error closing bufer reader");
                return;               
            }        
        }   
        else {  
            stringLength=newLine.length();
            System.out.println(" ");
            System.out.print
                    (" Input Program line "+programLine+" Read "+newLine);           
            charArray=newLine.toCharArray();
                                    
            if (stringLength==3) {
                programLine+=1;    
                alfa=charArray[0];                
                beta=charArray[1];
                addressSymbol=addressCode(alfa);                    
                instrSymbol=instructionCode(beta);                   
                System.out.print(" Code with Address ");
                if (alfa>='8')  {System.out.print("& Split ");}
                System.out.print (" Symbol Code "+addressSymbol);
                
                if (alfa>='9')  {  System.out.print("/"+instrSymbol);}
                else     {   System.out.print(instrSymbol);}

                //Build buffer string for output file
                if(addressSymbol!='M') { sb.append(addressSymbol);}
                if (alfa>='9') {sb.append("/");}
                sb.append(instrSymbol);
                if(programLine<programLineEnd){
                    sb.append("   "); 
                    sb.append("\n"); 
                }
                else if(programLine==programLineEnd){
                    sb.append("   "); 
                }
                
                //Compute Parity Chek Digit
                checkComputedA=parityCheck(alfa);                
                checkComputedB=parityCheck(beta);
                if(checkComputedA==checkComputedB){  parityFlag=false;}
                else {parityFlag=true;}
                checkReadFlag=(charArray[2]=='1');
                if (parityFlag!=checkReadFlag)  {
                System.out.println(" Address Parity "+checkComputedA+
                    " Instruction Parity "+checkComputedB);        
                System.out.println(" Computed Parity "+parityFlag+
                        " Read Parity "+checkReadFlag);
                    Emula.P101.setError(" Parity Card Error");
                    return;
                }
            }
            else {
                System.err.println(" Error reading file - Record <> 3"); 
                return;
            }
        }
    }                          
    System.out.println(sb.toString());  
    try{
        fr.close();
    }
    catch (Exception e){
        System.err.println(" Error closing file reader"); 
        return;
    }
    Card.CardChoice fileWSChooser = new Card.CardChoice(
        Emula.P101.userdir+"/../Service/Card/TXT","Select file text ", true); 
    if(CardChoice.unchoosenFlag)    return;       
    
    //WRite Card File  
    try {
        PrintWriter out1 = new PrintWriter(new BufferedWriter
              (new FileWriter(fileWSChooser.selectedFile)));
        System.out.println(" Text File " +fileWSChooser.selectedFile);
        out1.println(sb.toString());
        out1.close();
    }
    catch(Exception e) {
        System.err.println(" Error writing file "+fileWSChooser.selectedFile);
    }
  }
  
    static char  addressCode(char code)   {
      char addCode=' ';
      switch    (code){
        case '0':
            addCode='M';
            break;
        case '1':
            addCode='C';
            break;
        case '2':
            addCode='R';
            break;
        case '3':
            addCode='D';
            break;
        case '4':
            addCode='A';
            break;
        case '5':
            addCode='B';
            break;
        case '6':
            addCode='F';
            break;
        case '7':
            addCode='E';
            break;
        case '8':
            addCode='/';
            break;
        case '9':
            addCode='C';
            break;
        case 'A':
            addCode='R';
            break;
        case 'B':
            addCode='D';
            break;
        case 'C':
            addCode='A';
            break;
        case 'D':
            addCode='B';
            break;
        case 'E':
            addCode='F';
            break;
        case 'F':
            addCode='E';
            break;
        default:
            break;              
      }     
      return addCode;
  }
  
    static char  instructionCode(char code)   {
      char instrCode=' ';
      switch    (code){
        case '0':
            instrCode='S';
            break;
        case '1':
            instrCode='d';
            break;
        case '2':
            instrCode='u';
            break;
        case '3':
            instrCode='e';
            break;
        case '4':
            instrCode='+';
            break;
        case '5':
            instrCode='-';
            break;
        case '6':
            instrCode='X';
            break;
        case '7':
            instrCode=':';
            break;
        case '8':
            instrCode='p';
            break;
        case '9':
            instrCode='*';
            break;
        case 'B':
            instrCode='r';
            break;
        case 'C':
            instrCode='V';
            break;
        case 'D':
            instrCode='W';
            break;
        case 'E':
            instrCode='Y';
            break;
        case 'F':
            instrCode='Z';
            break;
        default:
            break;              
      }     
      return instrCode;
  }
  
  static boolean  parityCheck(char code)   {
      boolean charCheck;
      switch    (code){
          case '0':
          case '3':
          case '5':
          case '6':
          case '9':
          case 'A':
          case 'C':
          case 'F':
              charCheck=false;
            break;
          case '1':
          case '2':
          case '4':
          case '7':
          case '8':
          case 'B':
          case 'D':
          case 'E':
              charCheck=true;
              break;
          default:
              charCheck=true;              
      }     
      return charCheck;
  }
} 
 
 

