
package Card;

import java.io.File;
import java.io.FileWriter;
import java.io.BufferedWriter;

/**
 *
 * @author by gigi - Ivrea TO -
 */
public class CardWrite {
    static int programLine=1;
    static boolean fileOk=true; 
    static boolean newRegisterFlag=false; 
    static boolean cardParityError=false;
    static int charProgramm=0; 
    static File f;
    static FileWriter fw =null;
    static BufferedWriter bufwriter;
    
    public  CardWrite(File f) {
        try {
            fw = new FileWriter(f);
        }
        catch  (Exception e) {
        
        }
        bufwriter = new BufferedWriter(fw);   
    }
    
    public static void writeCardByte()  {     
        int instrCode;
        int aComputedCheck;
        int iComputedCheck;
        char computedCheck;    
        fileOk =true;
        char[]parityArray =  {'0','1','1','0','1','0','0','1',
            '1','0','0','1','0','1','1','0'} ;
        char[]hexArray = {'0','1','2','3','4','5','6','7','8','9',
            'A','B','C','D','E','F'};
     
        if (fileOk) {
            //Read instruction code from Program register
            instrCode=physicalCardCycle();   
            //Compute parity check
            aComputedCheck=parityArray[instrCode&0x0F];
            iComputedCheck=parityArray[instrCode/16];
            if(aComputedCheck==iComputedCheck) computedCheck='0';
            else computedCheck='1';
    
            //Write Instruction code & parity check to magnetic card file                        
            try{  
                fw.write(hexArray[instrCode&0x0f]);
                fw.write(hexArray[instrCode/16]);
                fw.write(computedCheck);
                if(programLine<120)
                    fw.write('\n');
            }
            catch  (Exception e) {
            
            }            
            System.out.print(" Program line "+programLine+ " Write - Code ");
                if((instrCode&0x0f)!=0)    
                        System.out.print(hexArray[instrCode&0x0f]);
                System.out.print (hexArray[instrCode/16]);
                System.out.print (" Parity check "+computedCheck);
            if (!fileOk){
                try{
                    System.out.println(" Card write end ");  
                    fw.close();
                }
                catch  (Exception e)  {
                    
                }
            }
            else {  
                System.out.println(" Wait for write next byte");                                   
                programLine+=1;                             
            }
        }
    }
    
    static int physicalCardCycle(){ 
        // Move P101 registers to card
        int charValue;
        int iCode;   

        // Move TA in char 24 of
        if(Emula.P101.firstCardCycle){
            programLine=1;
            Emula.P101.indexPgReg=0;                        
            if (Emula.P101.printProgram) Emula.P101.indexPgReg=3;            
        
            Emula.P101.firstCardCycle =false;
                //Delete previus TA in R
            for (int i=23;i>=0;i--)   {
                charValue=Emula.P101.readRegChar(7, i);
                Emula.P101.writeRegChar(7,i,charValue&0xfe);
            }
            // Write TA in 24° char of R
            charValue=Emula.P101.readRegChar(7, 23);
            Emula.P101.writeRegChar(7,23,charValue|0x01);
                             
            Emula.P101.pgReg=Emula.P101.pgRegTable[Emula.P101.indexPgReg];
            iCode=Emula.P101.readRegChar(Emula.P101.pgReg,0);
            //Move TA on R from char 23 to char 0
            Emula.P101.writeRegChar(7,23,charValue&0xf7);
            charValue=Emula.P101.readRegChar(7,0);
            Emula.P101.writeRegChar(7,0,charValue|0x01);
            Emula.P101.charTAofR=0;
        }
        else {
            // No first instruction
            charProgramm=Emula.P101.charTAofR+1;
            if (Emula.P101.charTAofR==23)charProgramm=0;
            iCode=Emula.P101.readRegChar(Emula.P101.pgReg,charProgramm);

            // Move TA of R
            charValue=Emula.P101.readRegChar (7,Emula.P101.charTAofR);
            Emula.P101.writeRegChar(7,Emula.P101.charTAofR,charValue&0xfe);
                
            Emula.P101.charTAofR+=1;
            if(Emula.P101.charTAofR==24)  Emula.P101.charTAofR=0;

            charProgramm+=1;
            if (charProgramm==24)   {
                charProgramm=0;
                if(Emula.P101.indexPgReg==4) {
                    Emula.P101.SOFlag=false;
                    fileOk=false;                
                    return iCode;
                }                    
                Emula.P101.indexPgReg+=1;
                Emula.P101.pgReg=Emula.P101.pgRegTable[Emula.P101.indexPgReg];
            }
            charValue=Emula.P101.readRegChar(7,Emula.P101.charTAofR);
            Emula.P101.writeRegChar(7,Emula.P101.charTAofR,charValue|0x01);
        }        
        return iCode;
    }
  }    
